---
title: FileSystemEntry.remove()
slug: Web/API/FileSystemEntry/remove
tags:
  - API
  - File System API
  - File and Directory Entries API
  - FileSystemEntry
  - Files
  - Method
  - Non-standard
  - Reference
  - delete
  - remove
---
<p>{{APIRef("File System API")}}{{Obsolete_header}}</p>

<p><span class="seoSummary">The {{domxref("FileSystemEntry")}} interface's method <code><strong>remove</strong></code><strong><code>()</code></strong> deletes the file or directory from the file system. Directories must be empty before they can be removed.</span></p>

<p>To recursively remove a directory as well as all of its contents and its subdirectories, call {{domxref("FileSystemDirectoryEntry.removeRecursively()")}} instead.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>FileSystemEntry</em>.remove(<em>successCallback</em>[, <em>errorCallback</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>successCallback</code></dt>
 <dd>A function which is called once the file has been successfully removed.</dd>
 <dt><code>errorCallback</code> {{optional_inline}}</dt>
 <dd>An optional callback which is called if the attempt to remove the file fails.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h3 id="Errors">Errors</h3>

<dl>
 <dt><code>FileError.INVALID_MODIFICATION_ERR</code></dt>
 <dd>The specified entry was the file system's root directory, or the specified entry is a directory which isn't empty.</dd>
 <dt><code>FileError.INVALID_STATE_ERR</code></dt>
 <dd>The file system's cached state is inconsistent with its state on disk, so the file could not be deleted for safety reasons.</dd>
 <dt><code>FileError.NO_MODIFICATION_ALLOWED_ERR</code></dt>
 <dd>The file system's state doesn't permit removing the file or directory.</dd>
 <dt><code>FileError.NOT_FOUND_ERR</code></dt>
 <dd>The file or directory doesn't exist.</dd>
 <dt><code>FileError.SECURITY_ERR</code></dt>
 <dd>The entry couldn't be removed due to permissions or other access constraints, or because there are too many calls being made on file resources.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example deletes a temporary work file.</p>

<pre class="brush: js">workingDirectory.getFile("tmp/workfile.json", {}, function(fileEntry) {
  fileEntry.remove(function() {
    /* the file was removed successfully */
  });
}, handleError);</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemEntry.remove")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
 <li>{{domxref("FileSystemDirectoryEntry.removeRecursively()")}}</li>
</ul>
